VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3636
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   5184
   LinkTopic       =   "Form1"
   Picture         =   "Form1.frx":0000
   ScaleHeight     =   3636
   ScaleWidth      =   5184
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox ShiftText 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   372
      Left            =   1560
      TabIndex        =   5
      Top             =   2520
      Width           =   612
   End
   Begin VB.TextBox OutputText 
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   396
      Left            =   1560
      TabIndex        =   2
      Top             =   1440
      Width           =   2532
   End
   Begin VB.TextBox InputText 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   396
      Left            =   1560
      TabIndex        =   1
      Top             =   960
      Width           =   2532
   End
   Begin VB.CommandButton ShiftButton 
      Caption         =   "Shift"
      Height          =   372
      Left            =   240
      TabIndex        =   0
      Top             =   2520
      Width           =   1212
   End
   Begin VB.Label Label2 
      Caption         =   "Output"
      Height          =   252
      Left            =   240
      TabIndex        =   4
      Top             =   1440
      Width           =   852
   End
   Begin VB.Label Label1 
      Caption         =   "Input"
      Height          =   252
      Left            =   240
      TabIndex        =   3
      Top             =   960
      Width           =   1092
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
 '
 ' Visual Basic Sample Code provided by BITWISE MAGAZINE
 '
 '      http://www.bitwisemag.com
 '
 ' This code and information is provided "as is" without warranty of
 ' any kind, either expressed or implied, including but not limited
 ' to the implied warranties of merchantability and/or fitness for a
 ' particular purpose.
 '
 ' You may use and modify this code for your personal use only.
 ' You may also redistribute this code providing that
 ' a) No fee is charged
 ' b) This copyright notice is retained in the source code.
 '
 ' You may not use this code for commercial purposes
 ' without the express permission of the copyright holder
 '
 ' Copyright (c) 2006 Dermot Hogan
 '
 '
Option Explicit
Dim shiftValue As Integer
Dim inputValue(1) As Long
Dim outputValue(1) As Long
Dim s As String
Dim slen As Integer
Dim upper, lower As String
'
' this doesn't do any serious checking of the input
' but it does check for -ve numbers
Private Sub ShiftButton_Click()
   
    shiftValue = Val(ShiftText.Text)
    s = InputText.Text
    If Left(s, 1) = "-" Then
        MsgBox ("positive numbers only!")
        Exit Sub
    End If
    
    slen = Len(s)
    
       
    inputValue(0) = 0
    inputValue(1) = 0
    lower = s
    If Len(s) > 8 Then
        upper = Mid(s, 1, 8)
        inputValue(1) = Val("&H" + upper)
        lower = Mid(s, 9, slen - 8)
    End If
    inputValue(0) = Val("&H" + lower)
    
    Rotate64 (shiftValue)
    
    OutputText.Text = Format((Hex(inputValue(1))), "00000000") & Format(Hex(inputValue(0)), "00000000")
    
 End Sub


' shift left or right by upto 32 bits
Sub Rotate32(bits As Integer)
    Dim i As Integer
    Dim c As Long
    
    If (bits > 0) Then
    
        ' we need to shift left by one bit
        ' but we have to take account of overflow error from VB
        ' so mask accordingly
        For i = 1 To shiftValue
            c = inputValue(0) And &HC0000000
            inputValue(0) = inputValue(0) And &H3FFFFFFF
            inputValue(0) = inputValue(0) * 2
            ' rotate MSB into LSB
            If c And &H80000000 Then
                inputValue(0) = inputValue(0) Or 1
            End If
            ' set or clear MSB
            If c And &H40000000 Then
                inputValue(0) = inputValue(0) Or &H80000000
            Else
                inputValue(0) = inputValue(0) And &H7FFFFFFF
            End If
        
        Next
    Else
        For i = bits To -1
            c = inputValue(0) And &H80000001
            inputValue(0) = inputValue(0) And &H7FFFFFFF
            inputValue(0) = inputValue(0) \ 2
            ' rotate MSB into LSB
            If c And 1 Then
                inputValue(0) = inputValue(0) Or &H80000000
            End If
            ' set or clear the old sign bit
            If c And &H80000000 Then
                inputValue(0) = inputValue(0) Or &H40000000
            Else
                inputValue(0) = inputValue(0) And &HBFFFFFFF
            End If
        Next
    End If

End Sub


' shift left or right by upto 64 bits
Sub Rotate64(bits As Integer)
    Dim i As Integer
    Dim c(1) As Long
    
    If (bits > 0) Then
    
        ' we need to shift left by one bit
        ' but we have to take account of overflow error from VB
        ' so mask accordingly
        For i = 1 To shiftValue
            c(0) = inputValue(0) And &HC0000000
            c(1) = inputValue(1) And &HC0000000
            inputValue(0) = inputValue(0) And &H3FFFFFFF
            inputValue(0) = inputValue(0) * 2
            inputValue(1) = inputValue(1) And &H3FFFFFFF
            inputValue(1) = inputValue(1) * 2
            ' rotate MSB into LSB
            If c(1) And &H80000000 Then
                inputValue(0) = inputValue(0) Or 1
            End If
            ' set MSB
            If c(1) And &H40000000 Then
                inputValue(1) = inputValue(1) Or &H80000000
            Else
                inputValue(1) = inputValue(1) And &H7FFFFFFF
            End If
            If c(0) And &H80000000 Then
                inputValue(1) = inputValue(1) Or 1
            End If
            ' set MSB
            If c(0) And &H40000000 Then
                inputValue(0) = inputValue(0) Or &H80000000
            Else
                inputValue(0) = inputValue(0) And &H7FFFFFFF
            End If
        Next
    Else
        For i = bits To -1
            c(0) = inputValue(0) And &H80000001
            c(1) = inputValue(1) And &H80000001
            inputValue(0) = inputValue(0) And &H7FFFFFFF
            inputValue(1) = inputValue(1) And &H7FFFFFFF
            inputValue(0) = inputValue(0) \ 2
            inputValue(1) = inputValue(1) \ 2
            ' rotate MSB into LSB
            If c(0) And 1 Then
                inputValue(1) = inputValue(1) Or &H80000000
            End If
            If c(1) And 1 Then
                inputValue(0) = inputValue(0) Or &H80000000
            End If
            ' set or clear the old sign bit
            If c(0) And &H80000000 Then
                inputValue(0) = inputValue(0) Or &H40000000
            Else
                inputValue(0) = inputValue(0) And &HBFFFFFFF
            End If
            If c(1) And &H80000000 Then
                inputValue(1) = inputValue(1) Or &H40000000
            Else
                inputValue(1) = inputValue(1) And &HBFFFFFFF
            End If
        Next
    End If



End Sub
